(define-module (type dnat-rule)
  :use-module (srfi srfi-2)
  :use-module (alterator woo)
  :use-module ((type ip-proto) #:prefix ip-proto:)
  :use-module ((type ip-address) #:prefix ip-address:)
  :use-module ((type tcp-port) #:prefix tcp-port:)
  :export (type))

(define (type v _)
  (or
    (and-let* ((proto-addr-port (string-split v #\:))
	       (proto (and (list? proto-addr-port)
			   (not (null? proto-addr-port))
			   (car proto-addr-port)))
	       (addr (and (list? proto-addr-port)
			  (list? (cdr proto-addr-port))
                          (not (null? (cdr proto-addr-port)))
			  (cadr proto-addr-port)))
	       (port (and (list? proto-addr-port)
			  (list? (cddr proto-addr-port))
                          (not (null? (cddr proto-addr-port)))
			  (caddr proto-addr-port))))
        (and (ip-proto:type proto _)
	     (ip-address:type addr _)
	     (tcp-port:type port _)))
    (type-error (_ "invalid DNAT rule"))))
