(document:surround "/std/frame")
(po-domain "alterator-net-iptables")

;;; Functions

(define (read-from-backend)
  (catch/message (lambda ()
    (let ((ipv (form-value "ipv")))
      (form-update-enum "ip" (woo-list "/net-bl" 'ipv ipv))
      (form-update-value-list
        '("status" "ip") (woo-read-first "/net-bl" 'ipv ipv)) ))))

(define (switch)
  (catch/message (lambda ()
    (woo "switch" "/net-bl" 'status (form-value "status") 'ipv (form-value "ipv")))))

(define (add)
  (catch/message (lambda ()
    (woo "add" "/net-bl" 'new_ip (form-value "new_ip") 'ipv (form-value "ipv")) ))
  (form-update-value "new_ip" "")
  (read-from-backend))

(define (del)
  (catch/message (lambda ()
    (woo "del" "/net-bl"
      'ip (form-value "ip") 'ipv (form-value "ipv"))))
  (read-from-backend))

(define (init-ui)
  (catch/message (lambda()
    (let ((available-ip-versions (woo-list "/net-iptables/ipv" 'language (form-value "language"))))
      (form-update-enum "ipv" available-ip-versions)
      ;; Don't show IP version selector if only one IP version is available
      (form-update-visibility "area-ipv-select" (not (= (length available-ip-versions) 1))))))
  (form-update-value "ipv" "4")
  (read-from-backend))

;;; UI

(gridbox
  columns "40;40;20"
  margin 20

  (hbox name "area-ipv-select" align "left" colspan 3
        (label text (_ "Select IP version:"))
        (combobox name "ipv"))

  (checkbox text (_ "Enable blacklist filtering") name "status" colspan 3)

  (label text (_ "Blacklist:") align "top" colspan 3)

  (listbox name "ip" colspan 2)
  (button text (_ "Delete") name "del" align "top")

  (label text (_ "Add new IP:") colspan 3)

  (label text (_ "Add host or network IP-address:") align "right")
  (edit name "new_ip")
  (button text (_ "Add") name "add")
)

(document:root (when loaded (init-ui))
               (form-bind "ipv"    "change" read-from-backend)
               (form-bind "status" "change" switch)
               (form-bind "add"    "click"  add)
               (form-bind "del"    "click"  del))

