(document:surround "/std/frame")
(po-domain "alterator-net-iptables")

;;; Functions
(define (read)
  (catch/message (lambda ()
    (form-update-enum "rule" (woo-list "/net-dnat/rules"))
    (form-update-value-list
      '("status" "rule" "proto" "ip1" "p1" "ip2" "p2")
      (woo-read-first "/net-dnat")) )))

(define (switch)
  (catch/message (lambda ()
    (woo "switch" "/net-dnat" 'status (form-value "status")))))

;; TODO: There is no error message in case of type-error, just a empty
;; message box, should be investigated.
(define (add)
  (catch/message (lambda ()
    (woo "add" "/net-dnat"
      'proto (form-value "proto")
      'ip1   (form-value "ip1")
      'p1    (form-value "p1")
      'ip2   (form-value "ip2")
      'p2    (form-value "p2") )))
  (read))

;; TODO: There is no error message in case of type-error, just a empty
;; message box, should be investigated.
(define (del)
  (catch/message (lambda ()
    (woo "del" "/net-dnat"
      'rule (form-value "rule") )))
  (read) )

(define (init-ui)
  (catch/message (lambda ()
    (form-update-enum "proto"
      (woo-list "/net-dnat/protocols"))
    (form-update-enum "ip1"
      (woo-list "/net-dnat/our_ips")) ))
  (read))

;;; UI

(gridbox
  columns "99;1"
  margin 20

  (checkbox text (_ "Enable port forwarding") name "status" colspan 2)

  (label text (_ "Available rules:") align "top" colspan 2)

  (document:id rule
    (listbox name "rule" enumref "net-dnat/rules"))
  (button name "del" text (_ "Delete") align "top")

  (label text (_ "Add new rule:") colspan 2)

  (gridbox columns "44;44;2;10"

    (spacer)
    (gridbox columns "50;50"
      (label text (_ "protocol:") align "right")
      (document:id proto
        (combobox name "proto" enumref "net-dnat/protocols")) )
    (spacer)
    (spacer)

    (label text (_ "destination IP address:") align "right")
    (document:id ip1 (combobox name "ip1" enumref "net-dnat/our_ips"))
    (label text (_ "port:") align "right")
    (document:id p1 (edit name "p1"))

    (label text (_ "forward to IP address:") align "right")
    (document:id ip2 (edit name "ip2"))
    (label text (_ "port:") align "right")
    (document:id p2 (edit name "p2"))
  )
  (button name "add" text (_ "Add"))
)

(document:root (when loaded
  (init-ui))
  (form-bind "status"  "change" switch)
  (form-bind "add"     "click"  add)
  (form-bind "del"     "click"  del))
