(define-module (ui net-iptables-manual ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :use-module (alterator card-index)
    :export (init))

(define (hide-buttons)
  (form-update-visibility "reset" (form-value "status"))
  (form-update-visibility "apply" (form-value "status"))
)

(define (ui-read)
  (let* ((ipv (form-value "ipv"))
         (name (f-get-ci-value "name" 'ipv ipv)))
    (f-reset "/net-iptables-manual" 'name name 'ipv ipv))
  (hide-buttons))

(define (ui-write)
  (let* ((ipv (form-value "ipv"))
        (name (f-get-ci-value "name" 'ipv ipv) ))
    (f-submit "/net-iptables-manual" 'name name 'ipv ipv))
  (ui-read))

(define (ui-switch)
  (catch/message (lambda ()
    (woo "switch" "/net-iptables-manual" 'ipv (form-value "ipv") 'status (form-value "status"))))
  (ui-read))

(define (ui-ipv-changed)
  (f-update-ci-list "name" "/net-iptables-manual" 'ipv (form-value "ipv"))
  (ui-read))

(define (ui-init)
  (catch/message (lambda()
    (let ((available-ip-versions (woo-list "/net-iptables/ipv" 'language (form-value "language"))))
      (form-update-enum "ipv" available-ip-versions)
      ;; Don't show IP version selector if only one IP version is available
      (form-update-visibility "ipv" (not (= (length available-ip-versions) 1))))))
  (form-update-value "ipv" "4")
  (ui-ipv-changed))

(define (init)
  (ui-init)
  (form-bind "ipv"     "change" ui-ipv-changed)
  (form-bind "status"  "change" ui-switch)
  (form-bind "name"    "change" ui-read)
  (form-bind "reset"   "click"  ui-read)
  (form-bind "apply"   "click"  ui-write))
