(define-module (ui net-iptables ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :use-module (alterator card-index)
    :export (init))

(define (on-read)
  (let ((ipv (form-value "ipv")))
    (f-update-list "external_ifaces" "/net-iptables/ifaces" 'ipv ipv)
    (f-update-list "opened_services" "/net-iptables/services" 'ipv ipv)
    (f-update-list "mode"            "/net-iptables/modes" 'ipv ipv)
    (f-reset  "/net-iptables" 'ipv ipv)
    (form-update-visibility "manmode_warn" (not (form-value "commit_mode")))
    (update-ifaces-activity)))

(define (on-write)
  (f-submit "/net-iptables")
  (f-reset  "/net-iptables" 'ipv (form-value "ipv"))
  (update-ifaces-activity))

(define (update-ifaces-activity)
  (form-update-activity "external_ifaces" (not (string=? (form-value "mode") "host"))))

(define (init)
  (let ((available-ip-versions (woo-list "/net-iptables/ipv" 'language (form-value "language"))))
    (form-update-enum "ipv" available-ip-versions)
    ;; Don't show IP version selector if only one IP version is available
    (form-update-visibility "ipv" (not (= (length available-ip-versions) 1))))
  (form-update-value "ipv" "4")
  (on-read)
  (form-bind "ipv"    "change" on-read)
  (form-bind "submit"  "click" on-write)
  (form-bind "reset"   "click" on-read) )

